package org.cagrid.mpirun.context.client;

import java.io.InputStream;
import java.rmi.RemoteException;

import javax.xml.namespace.QName;

import org.apache.axis.EngineConfiguration;
import org.apache.axis.client.AxisClient;
import org.apache.axis.client.Stub;
import org.apache.axis.configuration.FileProvider;
import org.apache.axis.message.addressing.EndpointReferenceType;
import org.apache.axis.types.URI.MalformedURIException;

import org.oasis.wsrf.properties.GetResourcePropertyResponse;

import org.globus.gsi.GlobusCredential;

import org.cagrid.mpirun.context.stubs.MPIRunResultResourcePortType;
import org.cagrid.mpirun.context.stubs.service.MPIRunResultResourceServiceAddressingLocator;
import org.cagrid.mpirun.context.common.MPIRunResultResourceI;
import gov.nih.nci.cagrid.introduce.security.client.ServiceSecurityClient;

/**
 * This class is autogenerated, DO NOT EDIT GENERATED GRID SERVICE ACCESS METHODS.
 *
 * This client is generated automatically by Introduce to provide a clean unwrapped API to the
 * service.
 *
 * On construction the class instance will contact the remote service and retrieve it's security
 * metadata description which it will use to configure the Stub specifically for each method call.
 * 
 * @created by Introduce Toolkit version 1.2
 */
public class MPIRunResultResourceClient extends MPIRunResultResourceClientBase implements MPIRunResultResourceI {	

	public MPIRunResultResourceClient(String url) throws MalformedURIException, RemoteException {
		this(url,null);	
	}

	public MPIRunResultResourceClient(String url, GlobusCredential proxy) throws MalformedURIException, RemoteException {
	   	super(url,proxy);
	}
	
	public MPIRunResultResourceClient(EndpointReferenceType epr) throws MalformedURIException, RemoteException {
	   	this(epr,null);
	}
	
	public MPIRunResultResourceClient(EndpointReferenceType epr, GlobusCredential proxy) throws MalformedURIException, RemoteException {
	   	super(epr,proxy);
	}

	public static void usage(){
		System.out.println(MPIRunResultResourceClient.class.getName() + " -url <service url>");
	}
	
	public static void main(String [] args){
	    System.out.println("Running the Grid Service Client");
		try{
		if(!(args.length < 2)){
			if(args[0].equals("-url")){
			  MPIRunResultResourceClient client = new MPIRunResultResourceClient(args[1]);
			  // place client calls here if you want to use this main as a
			  // test....
			} else {
				usage();
				System.exit(1);
			}
		} else {
			usage();
			System.exit(1);
		}
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

  public org.oasis.wsrf.lifetime.DestroyResponse destroy(org.oasis.wsrf.lifetime.Destroy params) throws RemoteException {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"destroy");
    return portType.destroy(params);
    }
  }

  public org.oasis.wsrf.lifetime.SetTerminationTimeResponse setTerminationTime(org.oasis.wsrf.lifetime.SetTerminationTime params) throws RemoteException {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"setTerminationTime");
    return portType.setTerminationTime(params);
    }
  }

  public java.lang.String getStatus(org.cagrid.mpirun.context.stubs.types.MPIRunResultResourceReference resReference) throws RemoteException {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"getStatus");
    org.cagrid.mpirun.context.stubs.GetStatusRequest params = new org.cagrid.mpirun.context.stubs.GetStatusRequest();
    org.cagrid.mpirun.context.stubs.GetStatusRequestResReference resReferenceContainer = new org.cagrid.mpirun.context.stubs.GetStatusRequestResReference();
    resReferenceContainer.setMPIRunResultResourceReference(resReference);
    params.setResReference(resReferenceContainer);
    org.cagrid.mpirun.context.stubs.GetStatusResponse boxedResult = portType.getStatus(params);
    return boxedResult.getResponse();
    }
  }

  public java.lang.String getDir(org.cagrid.mpirun.context.stubs.types.MPIRunResultResourceReference resReference) throws RemoteException {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"getDir");
    org.cagrid.mpirun.context.stubs.GetDirRequest params = new org.cagrid.mpirun.context.stubs.GetDirRequest();
    org.cagrid.mpirun.context.stubs.GetDirRequestResReference resReferenceContainer = new org.cagrid.mpirun.context.stubs.GetDirRequestResReference();
    resReferenceContainer.setMPIRunResultResourceReference(resReference);
    params.setResReference(resReferenceContainer);
    org.cagrid.mpirun.context.stubs.GetDirResponse boxedResult = portType.getDir(params);
    return boxedResult.getResponse();
    }
  }

  public boolean killProcess(org.cagrid.mpirun.context.stubs.types.MPIRunResultResourceReference resReference) throws RemoteException {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"killProcess");
    org.cagrid.mpirun.context.stubs.KillProcessRequest params = new org.cagrid.mpirun.context.stubs.KillProcessRequest();
    org.cagrid.mpirun.context.stubs.KillProcessRequestResReference resReferenceContainer = new org.cagrid.mpirun.context.stubs.KillProcessRequestResReference();
    resReferenceContainer.setMPIRunResultResourceReference(resReference);
    params.setResReference(resReferenceContainer);
    org.cagrid.mpirun.context.stubs.KillProcessResponse boxedResult = portType.killProcess(params);
    return boxedResult.isResponse();
    }
  }

  public java.lang.String[] getFiles(org.cagrid.mpirun.context.stubs.types.MPIRunResultResourceReference resReference) throws RemoteException {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"getFiles");
    org.cagrid.mpirun.context.stubs.GetFilesRequest params = new org.cagrid.mpirun.context.stubs.GetFilesRequest();
    org.cagrid.mpirun.context.stubs.GetFilesRequestResReference resReferenceContainer = new org.cagrid.mpirun.context.stubs.GetFilesRequestResReference();
    resReferenceContainer.setMPIRunResultResourceReference(resReference);
    params.setResReference(resReferenceContainer);
    org.cagrid.mpirun.context.stubs.GetFilesResponse boxedResult = portType.getFiles(params);
    return boxedResult.getResponse();
    }
  }

  public byte[] getFile(org.cagrid.mpirun.context.stubs.types.MPIRunResultResourceReference resReference,java.lang.String filename) throws RemoteException {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"getFile");
    org.cagrid.mpirun.context.stubs.GetFileRequest params = new org.cagrid.mpirun.context.stubs.GetFileRequest();
    org.cagrid.mpirun.context.stubs.GetFileRequestResReference resReferenceContainer = new org.cagrid.mpirun.context.stubs.GetFileRequestResReference();
    resReferenceContainer.setMPIRunResultResourceReference(resReference);
    params.setResReference(resReferenceContainer);
    params.setFilename(filename);
    org.cagrid.mpirun.context.stubs.GetFileResponse boxedResult = portType.getFile(params);
    return boxedResult.getResponse();
    }
  }

}
