package org.cagrid.mpirun.context.service.globus.resource;

import org.cagrid.mpirun.context.common.MPIRunResultResourceConstants;
import org.cagrid.mpirun.context.stubs.MPIRunResultResourceResourceProperties;

import org.globus.wsrf.ResourceException;
import org.globus.wsrf.ResourceKey;
import org.globus.wsrf.impl.ResourceHomeImpl;
import org.globus.wsrf.impl.SimpleResourceKey;
import org.apache.axis.message.addressing.EndpointReferenceType;
import org.apache.axis.MessageContext;
import org.globus.wsrf.ResourceContext;
import org.globus.wsrf.utils.AddressingUtils;
import org.apache.axis.components.uuid.UUIDGen;
import org.apache.axis.components.uuid.UUIDGenFactory;

/** 
 * DO NOT EDIT:  This class is autogenerated!
 *
 * This class implements the resource home for the resource type represented
 * by this service.
 * 
 * @created by Introduce Toolkit version 1.2
 * 
 */
public class MPIRunResultResourceResourceHome extends ResourceHomeImpl {
        private static final UUIDGen UUIDGEN = UUIDGenFactory.getUUIDGen();


	/**
 	* Creates a new Resource, adds it to the list of resources managed by this resource home,
 	* and returns the key to the resource.
 	*/
	public ResourceKey createResource() throws Exception {
		// Create a resource and initialize it
		MPIRunResultResourceResource resource = (MPIRunResultResourceResource) createNewInstance();
		// Create the resource properties bean so that the resource can use it to hold the  resource property values
		MPIRunResultResourceResourceProperties props = new MPIRunResultResourceResourceProperties();
        
        // Get a unique id for the resource
        Object id = UUIDGEN.nextUUID();
        
        // Create the resource key set it on the resource
		// this key is used for index service registration
		ResourceKey key = new SimpleResourceKey(getKeyTypeName(), id);
		resource.setResourceKey(key);
		
        resource.initialize(props, MPIRunResultResourceConstants.RESOURCE_PROPERTY_SET, id);

		// Add the resource to the list of resources in this home
		add(key, resource);
		return key;
	}
	
	/**
 	* Take a resource key managed by this resource, locates the resource, and created a typed EPR for the resource.
 	*/
	public org.cagrid.mpirun.context.stubs.types.MPIRunResultResourceReference getResourceReference(ResourceKey key) throws Exception {
		MessageContext ctx = MessageContext.getCurrentContext();
		String transportURL = (String) ctx.getProperty(org.apache.axis.MessageContext.TRANS_URL);
		transportURL = transportURL.substring(0,transportURL.lastIndexOf('/') +1 );
		transportURL += "MPIRunResultResource";
		EndpointReferenceType epr = AddressingUtils.createEndpointReference(transportURL,key);
		org.cagrid.mpirun.context.stubs.types.MPIRunResultResourceReference ref = new org.cagrid.mpirun.context.stubs.types.MPIRunResultResourceReference();
		ref.setEndpointReference(epr);
		return ref;
	}

	/**
 	* Given the key of a resource managed by this resource home, a type resource will be returned.
 	*/	
	public MPIRunResultResourceResource getResource(ResourceKey key) throws ResourceException {
		MPIRunResultResourceResource thisResource = (MPIRunResultResourceResource)find(key);
		return thisResource;
	}
	
    /**
     * Get the resouce that is being addressed in this current context
     */
    public MPIRunResultResourceResource getAddressedResource() throws Exception {
        MPIRunResultResourceResource thisResource;
        thisResource = (MPIRunResultResourceResource) ResourceContext.getResourceContext().getResource();
        return thisResource;
    }

	
}