package org.cagrid.mpirun.client;

import java.io.InputStream;
import java.rmi.RemoteException;

import javax.xml.namespace.QName;

import org.apache.axis.EngineConfiguration;
import org.apache.axis.client.AxisClient;
import org.apache.axis.client.Stub;
import org.apache.axis.configuration.FileProvider;
import org.apache.axis.message.addressing.EndpointReferenceType;
import org.apache.axis.types.URI.MalformedURIException;

import org.oasis.wsrf.properties.GetResourcePropertyResponse;

import org.globus.gsi.GlobusCredential;

import org.cagrid.mpirun.stubs.MPIRunPortType;
import org.cagrid.mpirun.stubs.service.MPIRunServiceAddressingLocator;
import org.cagrid.mpirun.common.MPIRunI;
import gov.nih.nci.cagrid.introduce.security.client.ServiceSecurityClient;
import java.io.FileOutputStream;
import java.util.List;
import java.io.File;
import java.util.ArrayList;
import org.cagrid.mpirun.context.stubs.types.MPIRunResultResourceReference;
import org.cagrid.mpirun.context.client.MPIRunResultResourceClient;
import org.globus.wsrf.encoding.ObjectSerializer;
import org.apache.axis.types.URI;
import org.globus.wsrf.encoding.ObjectDeserializer;
import java.io.FileNotFoundException;
import java.io.BufferedWriter;
import org.xml.sax.InputSource;
import java.io.FileInputStream;
import java.io.FileWriter;

/**
 * This class is autogenerated, DO NOT EDIT GENERATED GRID SERVICE ACCESS METHODS.
 *
 * This client is generated automatically by Introduce to provide a clean unwrapped API to the
 * service.
 *
 * On construction the class instance will contact the remote service and retrieve it's security
 * metadata description which it will use to configure the Stub specifically for each method call.
 * 
 * @created by Introduce Toolkit version 1.2
 */
public class MPIRunClient extends MPIRunClientBase implements MPIRunI {	

	public MPIRunClient(String url) throws MalformedURIException, RemoteException {
		this(url,null);	
	}

	public MPIRunClient(String url, GlobusCredential proxy) throws MalformedURIException, RemoteException {
	   	super(url,proxy);
	}
	
	public MPIRunClient(EndpointReferenceType epr) throws MalformedURIException, RemoteException {
	   	this(epr,null);
	}
	
	public MPIRunClient(EndpointReferenceType epr, GlobusCredential proxy) throws MalformedURIException, RemoteException {
	   	super(epr,proxy);
	}

    public static void usage()
    {
        final String[] msg = new String[] {
            "Usage:  + MPIRunClient command [ opts ] [ args ]",
            "",
            "    commands available:",
            "        new [ new_opts ]",
            "",
            "        Where [new_opts] are:",
            "            -help                    Displays this message",
            "            -epr <file>              Save EPR in file",
            "            -url <URL>               URL of service",
            "            -type <mode>             block, gram, monitor(default)",
            "            -inputFile <file>        transfer file(s) to working directory",
            "            -execArgs <cmdline args> command-line arguments for executable",
            "",
            "        status [ status_opts ]",
            "        Where [status_opts] are:",
            "            -help                    Displays this message",
            "            -epr <file>              Use EPR in file",
        };
        
        for(int i=0; i<msg.length; i++) {
            System.out.println(msg[i]);
        }
        System.exit(1);
    }

	
    public static void main(String [] args)
    {
        if (args.length < 1) {
            usage();
        }
        
        for(int i=0; i<args.length; i++) {System.out.println("arg: " + args[i]);}
        final String command = args[0];
        
        if (command.equals("new")) {
            System.out.println("command new");
            runNew(args);
            return;
        }
        
        if (command.equals("status")) {
            System.out.println("command status");
            runStatus(args);
            return;
        }
        
        if (command.equals("kill")) {
            System.out.println("command kill");
            runKill(args);
            return;
        }
        
        usage();
    }


  public org.oasis.wsrf.properties.GetMultipleResourcePropertiesResponse getMultipleResourceProperties(org.oasis.wsrf.properties.GetMultipleResourceProperties_Element params) throws RemoteException {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"getMultipleResourceProperties");
    return portType.getMultipleResourceProperties(params);
    }
  }

  public org.oasis.wsrf.properties.GetResourcePropertyResponse getResourceProperty(javax.xml.namespace.QName params) throws RemoteException {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"getResourceProperty");
    return portType.getResourceProperty(params);
    }
  }

  public org.oasis.wsrf.properties.QueryResourcePropertiesResponse queryResourceProperties(org.oasis.wsrf.properties.QueryResourceProperties_Element params) throws RemoteException {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"queryResourceProperties");
    return portType.queryResourceProperties(params);
    }
  }

  public org.cagrid.mpirun.context.stubs.types.MPIRunResultResourceReference mpirun(java.lang.String[] arguments,java.lang.String[] inputFileNames,byte[][] inputFiles) throws RemoteException {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"mpirun");
    org.cagrid.mpirun.stubs.MpirunRequest params = new org.cagrid.mpirun.stubs.MpirunRequest();
    params.setArguments(arguments);
    params.setInputFileNames(inputFileNames);
    params.setInputFiles(inputFiles);
    org.cagrid.mpirun.stubs.MpirunResponse boxedResult = portType.mpirun(params);
    return boxedResult.getMPIRunResultResourceReference();
    }
  }

  public org.cagrid.mpirun.context.stubs.types.MPIRunResultResourceReference mpirunBLOCK(java.lang.String[] arguments,java.lang.String[] inputFileNames,byte[][] inputFiles) throws RemoteException {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"mpirunBLOCK");
    org.cagrid.mpirun.stubs.MpirunBLOCKRequest params = new org.cagrid.mpirun.stubs.MpirunBLOCKRequest();
    params.setArguments(arguments);
    params.setInputFileNames(inputFileNames);
    params.setInputFiles(inputFiles);
    org.cagrid.mpirun.stubs.MpirunBLOCKResponse boxedResult = portType.mpirunBLOCK(params);
    return boxedResult.getMPIRunResultResourceReference();
    }
  }

  public org.cagrid.mpirun.context.stubs.types.MPIRunResultResourceReference mpirunGRAM(java.lang.String[] arguments,java.lang.String[] inputFileNames,byte[][] inputFiles) throws RemoteException {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"mpirunGRAM");
    org.cagrid.mpirun.stubs.MpirunGRAMRequest params = new org.cagrid.mpirun.stubs.MpirunGRAMRequest();
    params.setArguments(arguments);
    params.setInputFileNames(inputFileNames);
    params.setInputFiles(inputFiles);
    org.cagrid.mpirun.stubs.MpirunGRAMResponse boxedResult = portType.mpirunGRAM(params);
    return boxedResult.getMPIRunResultResourceReference();
    }
  }


    protected static void decode(byte[] data, String directory)
    {
        // CodeGen: org.globus.ravi.codegen.module.ClientEditor
        String dataString = new String(data);
        byte[] bytes = org.apache.axis.encoding.Base64.decode(dataString);
        File file = new File(directory + "/", "output");
        FileOutputStream fos;
        
        System.out.println("Got encoded data length of " + dataString.length() + " bytes");
        
        try {
            fos = new java.io.FileOutputStream(file);
            fos.write(bytes);
            fos.close();
            System.out.println("Output file written properly to: " + directory + "/output");
        }catch (Exception e){
            System.out.println("Exception " + e);
        }
    }


    protected static MPIRunResultResourceReference loadEPRFromFile(File file)
    {
        // CodeGen: org.globus.ravi.codegen.module.ClientEditor
        FileInputStream fis;
        EndpointReferenceType epr;
        
        try {
            fis = new FileInputStream(file);
            epr = (EndpointReferenceType) ObjectDeserializer.deserialize(new InputSource(fis), EndpointReferenceType.class);
            fis.close();
        } catch (Exception e){
            System.out.println("Error reading epr from file " + e);
            return null;
        }
        
        MPIRunResultResourceReference resReference = new MPIRunResultResourceReference();
        resReference.setEndpointReference(epr);
        
        return resReference;
    }


    protected static void saveEPRToFile(MPIRunResultResourceReference resourceReference, String eprFilename)
    {
        // CodeGen: org.globus.ravi.codegen.module.ClientEditor
        String endpointString;
        FileWriter fileWriter;
        BufferedWriter bfWriter;
        
        try {
            endpointString = ObjectSerializer.toString(
                                 resourceReference.getEndpointReference(),
                                 new QName("http://mpirun.cagrid.org/MPIRun/Context","MPIRunResultResourceReference")
            );
        
            System.out.println("Attempting to write Endpoint reference to file " + eprFilename);
            fileWriter = new FileWriter(eprFilename);
            bfWriter = new BufferedWriter(fileWriter);
            bfWriter.write(endpointString);
            bfWriter.close();
            System.out.println("Endpoint reference written to file " + eprFilename);
        
        }catch (Exception e){
            System.out.println("Error writing epr to file " + e);
        }
        
    }


    private static byte[] encode(File f)
    {
        // CodeGen: org.globus.ravi.codegen.module.ClientEditor
        java.io.ByteArrayOutputStream os = new java.io.ByteArrayOutputStream();
        InputStream is;
        
        try {
            is = new java.io.FileInputStream(f);
        } catch (FileNotFoundException e) {
            throw new RuntimeException("Missing input file", e);
        }
        
        int numBytes = 0, numRead = 0;
        final byte[] buf = new byte[1024];
        
        while (numRead >= 0) {
            try {
                numBytes = is.available();
                if (numBytes > buf.length) {
                    numBytes = buf.length;
                }
                if (numBytes == 0) {
                    numBytes = 1;
                }
                numRead = is.read(buf, 0, numBytes);
                if (numRead == -1) {
                     break;
                }
                os.write(buf, 0, numRead);
            } catch (java.io.IOException e) {
                e.printStackTrace();
            }
        }
        
        byte[] bytes = os.toByteArray();
        String dataString = org.apache.axis.encoding.Base64.encode(bytes);
        return dataString.getBytes();
    }


    public static void runNew(String [] args)
    {
        // CodeGen: org.globus.ravi.codegen.module.ClientEditor
        final MPIRunClient client;
        String url = null;
        File file = new File("client.epr");
        final String monitor = "monitor";
        final String block = "block";
        final String gram = "gram";
        String[] arguments = new String[0];
        String type = monitor;
        List inputFiles = new ArrayList();
        
        for(int i=1; i<args.length; i++) {
            if(args[i].equals("-url")) {
                url = args[++i];
            } else if(args[i].equals("-type")) {
                type = args[++i];
            } else if(args[i].equals("-file")) {
                file = new File(args[++i]);
            } else if(args[i].equals("-inputFile")) {
                inputFiles.add(args[++i]);
            } else if(args[i].equals("-execArgs")) {
                arguments = args[++i].split(" ");
            } else {
                System.out.println("Unknown arg: " + args[i]);
                usage();
            }
        }
        
        if (url == null) {
            System.out.println("No URL Provided ");
            usage();
        }
        if (file.exists()) {
            System.out.println("EPR File exists");
            usage();
        }
        if (!( type.equals(monitor) || type.equals(block) || type.equals(gram) )) {
            System.out.println("Unknown type " + type);
            usage();
        }
        
        try {
            client = new MPIRunClient(url);
        } catch (URI.MalformedURIException e) {
            throw new IllegalArgumentException("Malformed URL: " + url, e);
        } catch (RemoteException e) {
            throw new IllegalArgumentException("Remote Exception", e);
        }
        
        String[] paths = (String[]) inputFiles.toArray(new String[0]);
        List namelist = new ArrayList();
        byte[][] data = new byte[paths.length][];
        File inputFile;
        
        for (int i=0; i<paths.length; i++) {
            inputFile = new File(paths[i]);
            namelist.add(inputFile.getName());
            data[i] = encode(inputFile);
        }
        
        MPIRunResultResourceReference resource;
        String[] names = (String[]) namelist.toArray(new String[0]);
        
        try {
            if (type.equals(monitor)) {
                resource = client.mpirun(arguments, names, data);
            } else if (type.equals(block)) {
                resource = client.mpirunBLOCK(arguments, names, data);
            } else if (type.equals(gram)) {
                resource = client.mpirunGRAM(arguments, names, data);
            } else {
                throw new RuntimeException("Must choose run as monitor, block, or gram.");
            }
        } catch (RemoteException e) {
            throw new RuntimeException("Error invoking command ", e);
        }
        
        saveEPRToFile(resource, file.getAbsolutePath()); 
    }


    public static void runKill(String [] args)
    {
        // CodeGen: org.globus.ravi.codegen.module.ClientEditor
        File file = new File("client.epr");
        
        if (args.length<1) { usage(); }
        
        for(int i=1; i<args.length; i++) {
            if(args[i].equals("-file")) {
                file = new File(args[++i]);
            } else {
                usage();
            }
        }
        
        if (file == null) {
            usage();
        }
        MPIRunResultResourceReference resReference = loadEPRFromFile(file);
        
        // now access the context service to get our particular resource.
        resReference.getEndpointReference();
        final MPIRunResultResourceClient resClient;
        try {
            resClient = new MPIRunResultResourceClient(resReference.getEndpointReference());
        } catch (RemoteException e) {
            // TODO: client.destroy, clean this up.
            throw new RuntimeException("Initialization of Context Service client", e);
        } catch (URI.MalformedURIException e) {
            throw new IllegalArgumentException("Malformed URL: ", e);
        }
        try {
            System.out.println("Killing Proc:" + resClient.killProcess(resReference) );
            System.out.println("Status:" + resClient.getStatus(resReference));
            resClient.destroy(null);
        } catch (RemoteException e) {
            throw new RuntimeException("Destroy Context Service client", e);
        }
        if (file.delete()) {
            System.out.println("Deleted File: " + file.getAbsolutePath());
        } else {
            System.out.println("Failed to delete File: " + file.getAbsolutePath());
        }
    }


    public static void runStatus(String [] args)
    {
        // CodeGen: org.globus.ravi.codegen.module.ClientEditor
        File file = new File("client.epr");
        
        if (args.length<1) { usage(); }
        
        for(int i=1; i<args.length; i++) {
            if(args[i].equals("-file")) {
                file = new File(args[++i]);
            } else {
                usage();
            }
        }
        
        if (file == null) {
            usage();
        }
        MPIRunResultResourceReference resReference = loadEPRFromFile(file);
        
        // now access the context service to get our particular resource.
        resReference.getEndpointReference();
        final MPIRunResultResourceClient resClient;
        try {
            resClient = new MPIRunResultResourceClient(resReference.getEndpointReference());
        } catch (RemoteException e) {
            // TODO: client.destroy, clean this up.
            throw new RuntimeException("Initialization of Context Service client", e);
        } catch (URI.MalformedURIException e) {
            throw new IllegalArgumentException("Malformed URL: ", e);
        }
        byte [] outputData;
        try {
            System.out.println("Working Dir: " + resClient.getDir(resReference));
            System.out.println("Status: " + resClient.getStatus(resReference));
            outputData = resClient.getFile(resReference, "output");
        } catch (RemoteException e) {
            // TODO: client.destroy, clean this up.
            throw new RuntimeException("Using Context Service client", e);
        }
        
        if (outputData !=null) {
            System.out.println("Got output file data ... decoding");
            decode(outputData, "./");
        }
        
    }

}
