package org.cagrid.mpirun.context.service;

import java.rmi.RemoteException;
import org.cagrid.mpirun.context.service.globus.resource.MPIRunResultResourceResourceHome;
import org.globus.wsrf.ResourceKey;
import javax.xml.namespace.QName;
import org.apache.axis.message.addressing.ReferencePropertiesType;
import org.cagrid.mpirun.context.service.globus.resource.MPIRunResultResourceResourceBase;
import java.io.File;
import java.io.FileInputStream;
import org.cagrid.mpirun.context.stubs.types.MPIRunResultResourceReference;
import org.globus.wsrf.impl.SimpleResourceKey;

/** 
 * TODO:I am the service side implementation class.  IMPLEMENT AND DOCUMENT ME
 * 
 * @created by Introduce Toolkit version 1.2
 * 
 */
public class MPIRunResultResourceImpl extends MPIRunResultResourceImplBase {

	
	public MPIRunResultResourceImpl() throws RemoteException {
		super();
	}
	
    public java.lang.String getStatus(MPIRunResultResourceReference resReference) throws RemoteException
    {
        // CodeGen: org.globus.ravi.codegen.module.ResourceContextServiceEditor
        Process process = null;
        org.globus.exec.client.GramJob job = null;
        int raveType;
        try { 
            ReferencePropertiesType referenceProperties = resReference.getEndpointReference().getProperties(); 
            ResourceKey rk = new SimpleResourceKey(new QName(referenceProperties.get_any()[0].getNamespaceURI(), referenceProperties.get_any()[0].getName()), referenceProperties.get_any()[0].getValue());
            MPIRunResultResourceResourceHome rh = this.getResourceHome();
            MPIRunResultResourceResourceBase resource = rh.getResource(rk);
            raveType = resource.getRaveType();
        
            if (raveType == 3) {
                job = resource.getJob();
            } else {
                process =  resource.getProcess();
            }
        } catch (Exception e){
            System.out.println("(ResultResourceImpl) Error getting Status" + e);
            return null;
        }
        
        int exitCode;
        
        if (raveType == 3){
            if (job.getState().equals(org.globus.exec.generated.StateEnumeration.Done)|| job.getState().equals(org.globus.exec.generated.StateEnumeration.Failed)){
                return "Finished:" + Integer.toString(job.getExitCode()); 
            }
        
            return "State: " + job.getState().getValue();
        }else {
            try { 
                exitCode = process.exitValue();
            } catch (IllegalThreadStateException itse){
                System.out.println("(ResultResourceImpl) getStatus - IllegalThreadState (means process is still running) " + itse);
                return "Running";
            }
        }
        
        return "Finished: " + exitCode;
    }


    public java.lang.String getDir(MPIRunResultResourceReference resReference) throws RemoteException
    {
        // CodeGen: org.globus.ravi.codegen.module.ResourceContextServiceEditor
        try { 
            ReferencePropertiesType referenceProperties = resReference.getEndpointReference().getProperties(); 
            ResourceKey rk = new SimpleResourceKey(new QName(referenceProperties.get_any()[0].getNamespaceURI(), referenceProperties.get_any()[0].getName()), referenceProperties.get_any()[0].getValue());
            MPIRunResultResourceResourceHome rh = this.getResourceHome();
            MPIRunResultResourceResourceBase resource = rh.getResource(rk);
            return resource.getDir().getAbsolutePath();
        } catch (Exception e){
            System.out.println("(ResultResourceImpl) Error getDir " + e);
        }
        
        return null;
    }


    public boolean killProcess(MPIRunResultResourceReference resReference) throws RemoteException
    {
        // CodeGen: org.globus.ravi.codegen.module.ResourceContextServiceEditor
        try { 
            ReferencePropertiesType referenceProperties = resReference.getEndpointReference().getProperties(); 
            ResourceKey rk = new SimpleResourceKey(new javax.xml.namespace.QName(referenceProperties.get_any()[0].getNamespaceURI(), referenceProperties.get_any()[0].getName()), referenceProperties.get_any()[0].getValue());
            MPIRunResultResourceResourceHome rh = this.getResourceHome();
            MPIRunResultResourceResourceBase resource = rh.getResource(rk);
        
            if (resource.getRaveType() == 3) {
                resource.getJob().destroy();
            } else {
                resource.getProcess().destroy();
            }
        } catch (Exception e){
            System.out.println("(ResultResourceImpl) Error killProcess" + e);
            return false;
        }
        
        return true;
    }


    public java.lang.String[] getFiles(MPIRunResultResourceReference resReference) throws RemoteException
    {
        // CodeGen: org.globus.ravi.codegen.module.ResourceContextServiceEditor
        String directory = getDir(resReference);
        if (directory == null)
            return null;
        
        File dir = new File(directory);
        String[] children = dir.list();
        
        return children;
    }


    public byte[] getFile(MPIRunResultResourceReference resReference, String filename) throws RemoteException
    {
        // CodeGen: org.globus.ravi.codegen.module.ResourceContextServiceEditor
        byte[] data = null;
        String directory = getDir(resReference);
        if (directory == null)
            return null;
        
        try {
            int numBytes = 0, totalBytes = 0, attempts = 0;
            byte[] bytes = null;
            String dataString = "";
            File file = new File(directory + "/output");
            FileInputStream stream = new FileInputStream(file);
        
            while(true) {
                numBytes = stream.available();
                if (numBytes == 0) {
                    if (attempts++ == 5) { break; }
                    Thread.sleep(100);
                    continue;
                }
                totalBytes += numBytes;
                bytes = new byte[numBytes];
                stream.read(bytes, 0, numBytes);
                dataString += org.apache.axis.encoding.Base64.encode(bytes);
            }
            System.out.println("Got output data of " + totalBytes + " bytes");
            stream.close();
            System.out.println("Total output data size is " + totalBytes + " bytes");
            System.out.println("Sending encoded output data of " + dataString.length() + " bytes");
            data = dataString.getBytes();
        }catch (Exception e){
            throw new RuntimeException("getFile failed", e);
        }
        return data;
    }


}

