package org.cagrid.mpirun.service;

import java.rmi.RemoteException;
import org.cagrid.mpirun.context.service.globus.resource.MPIRunResultResourceResourceHome;
import java.io.File;
import org.cagrid.mpirun.context.service.globus.resource.MPIRunResultResourceResourceBase;
import org.apache.commons.logging.Log;
import java.io.FileNotFoundException;
import org.apache.commons.logging.LogFactory;
import java.io.IOException;
import org.globus.exec.client.GramJob;
import org.globus.exec.generated.JobDescriptionType;
import org.apache.axis.message.addressing.EndpointReferenceType;
import org.globus.wsrf.impl.security.authorization.HostAuthorization;
import org.gridforum.jgss.ExtendedGSSManager;
import org.globus.exec.utils.client.ManagedJobFactoryClientHelper;
import org.globus.wsrf.impl.security.authorization.Authorization;
import org.apache.axis.components.uuid.UUIDGen;
import org.apache.axis.components.uuid.UUIDGenFactory;
import org.globus.exec.client.GramJobListener;
import org.ietf.jgss.GSSCredential;
import java.util.Date;
import java.net.URL;
import org.globus.wsrf.impl.security.authentication.Constants;
import org.globus.exec.generated.StateEnumeration;
import org.gridforum.jgss.ExtendedGSSCredential;
import org.globus.exec.utils.ManagedJobFactoryConstants;

/** 
 * TODO:I am the service side implementation class.  IMPLEMENT AND DOCUMENT ME
 * 
 * @created by Introduce Toolkit version 1.2
 * 
 */
public class MPIRunImpl extends MPIRunImplBase implements GramJobListener  {

	
	public MPIRunImpl() throws RemoteException {
		super();
	}
	
    public org.cagrid.mpirun.context.stubs.types.MPIRunResultResourceReference mpirun(java.lang.String[] arguments,java.lang.String[] inputFileNames,byte[][] inputFiles) throws RemoteException
    {
        
        final org.globus.wsrf.ResourceKey resourceKey;
        final MPIRunResultResourceResourceHome resourceHome;
        final MPIRunResultResourceResourceBase resource;
        final org.cagrid.mpirun.context.stubs.types.MPIRunResultResourceReference resourceReference;
        final ProcessBuilder pb;
        final Process process;
        
        try {
            pb = setup(arguments, inputFileNames, inputFiles);
            process = pb.start();
        } catch (java.io.IOException e) {
            e.printStackTrace();
            return null;
        }
        final File workingDir = pb.directory();
        
        class Executor implements Runnable {
            public void run() {
        monitor(process, workingDir);
            }
        };
        
        final Executor exec = new Executor();
        final Thread thread = new Thread(exec);
        thread.start();
        
        try {
            resourceHome = getMPIRunResultResourceResourceHome();
            resourceKey = resourceHome.createResource();
            resource = resourceHome.getResource(resourceKey);
            resourceReference = resourceHome.getResourceReference(resourceKey);
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        
        resource.setRaveType(1);
        resource.setDir(pb.directory());
        resource.setProcess(process);
        resource.setJob(null);
        
        return resourceReference;
    }


    public org.cagrid.mpirun.context.stubs.types.MPIRunResultResourceReference mpirunBLOCK(java.lang.String[] arguments,java.lang.String[] inputFileNames,byte[][] inputFiles) throws RemoteException
    {
        
        final org.globus.wsrf.ResourceKey resourceKey;
        final MPIRunResultResourceResourceHome resourceHome;
        final MPIRunResultResourceResourceBase resource;
        final org.cagrid.mpirun.context.stubs.types.MPIRunResultResourceReference resourceReference;
        final ProcessBuilder pb;
        final Process process;
        
        try {
            pb = setup(arguments, inputFileNames, inputFiles);
            process = pb.start();
        } catch (java.io.IOException e) {
            e.printStackTrace();
            return null;
        }
        final File workingDir = pb.directory();
        
        monitor(process, workingDir);
        
        try {
            resourceHome = getMPIRunResultResourceResourceHome();
            resourceKey = resourceHome.createResource();
            resource = resourceHome.getResource(resourceKey);
            resourceReference = resourceHome.getResourceReference(resourceKey);
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        
        resource.setRaveType(2);
        resource.setDir(workingDir);
        resource.setProcess(process);
        resource.setJob(null);
        
        return resourceReference;
    }


public org.cagrid.mpirun.context.stubs.types.MPIRunResultResourceReference mpirunGRAM(java.lang.String[] arguments,java.lang.String[] inputFileNames,byte[][] inputFiles) throws RemoteException    {
        loadProperties();
        File workingDir = createWorkingDirectory();
        
        if (!workingDir.exists()){
            throw new RuntimeException("Missing working directory: " + workingDir.getAbsolutePath());
        }
        
        try {
            decodeInputFiles(workingDir, inputFileNames, inputFiles);
        } catch (IOException e) {
            e.printStackTrace();
            logger.error("Failed to decode input files.");
            throw new RuntimeException(e);
        }
        
        JobDescriptionType jobDescription = createJobDescription("/usr/bin/mpirun", arguments);
        if (jobDescription == null){
           return null;
        }
        
        try {
            this.startGramJob(jobDescription);
        } catch (Exception e) {
            e.printStackTrace();
            logger.error("Failed to start Gram Job");
            throw new RuntimeException(e);
        }
        logger.debug("Job started");
        
        final org.globus.wsrf.ResourceKey resourceKey;
        final MPIRunResultResourceResourceHome resourceHome;
        final MPIRunResultResourceResourceBase resource;
        final org.cagrid.mpirun.context.stubs.types.MPIRunResultResourceReference resourceReference;
        
        try {
            resourceHome = getMPIRunResultResourceResourceHome();
            resourceKey = resourceHome.createResource();
            resource = resourceHome.getResource(resourceKey);
            resourceReference = resourceHome.getResourceReference(resourceKey);
        } catch (Exception e) {
            e.printStackTrace();
            logger.error("Failed to create Resource");
            throw new RuntimeException(e);
        }
        
        resource.setRaveType(3);
        resource.setDir(workingDir);
        resource.setProcess(null);
        resource.setJob(job);
        
        // Here we wait for a timeout - this will cause a fake notification
        // only use this fake notification as im testing on a machine that is
        // unable to send notifications to my client machine
        logger.debug("WAITING FOR JOB TO FINISH - REMOVE THIS!!!!");
        try {
            waitForJobCompletion(6000);
        } catch (Exception e) {
            e.printStackTrace();
            logger.error("Failed to wait for job to complete....");
            throw new RuntimeException(e);
        }
        logger.debug("Job Finished..");
        return resourceReference;
    }



    public void loadProperties()
    {
            try {
                properties.load(new java.io.FileInputStream("etc/cagrid_MPIRun/rave.properties"));
            } catch (java.io.IOException e) {
                logger.error("Getting properties file..." + e + "\nAt the moment this is relative path restart container from $GLOBUS_LOCATION");
                throw new RuntimeException(e);
            }
        
            String path = properties.getProperty("BaseDirectory");
            if (path.length() == 0) {
                path = System.getProperty("GLOBUS_LOCATION");
            }
            baseDirectory = new File(path);
        // CodeGen: org.globus.ravi.codegen.module.GramServiceEditor
        GRAMContact = properties.getProperty("GRAM");
        factoryType = properties.getProperty("GRAMType");
        proxyPath = properties.getProperty("ProxyPath");
    }
// CodeGen: org.globus.ravi.codegen.module.ExecutionServiceEditor
    
    // >>> Head org.globus.ravi.codegen.module.AbstractExecutorServiceEditor
    private File baseDirectory;
    final private static Log logger = LogFactory.getLog(MPIRunImpl.class);
    final private java.util.Properties properties = new java.util.Properties();
    final private static String EXECUTABLE_PATH = "/usr/bin/mpirun";
    final private static String STDOUT_FILENAME = "output";
    final private static String STDERR_FILENAME = "error";
    final private static int BUFFER_READER_SIZE = 1024;
    



    public File createWorkingDirectory()
    {
        java.util.Date date = new java.util.Date();
        long time = date.getTime();
        File workingDir = new File(baseDirectory , "MPIRun" + time);
        boolean success = workingDir.mkdirs();
        
        if (!success) {
            logger.error("Couldnt create dir: "  + workingDir);
            return null;
        }
        
        logger.debug("Directory created: "  + workingDir);
        return workingDir;
    }


    public void decodeInputFiles(File workingDir, String[] fileNames, byte[][] inputFiles) throws IOException,FileNotFoundException
    {
        if (inputFiles != null){
            java.io.File file;
            java.io.FileOutputStream fos;
            String dataString;
            byte[] bytes;
        
            for (int i=0; i<inputFiles.length; i++) {
                dataString = new String(inputFiles[i]);
                bytes = org.apache.axis.encoding.Base64.decode(dataString);
                file = new java.io.File(workingDir, fileNames[i]);
                fos = new java.io.FileOutputStream(file);
        
                try {
                    fos.write(bytes);
                } finally {
                    fos.close();
                }
            }
        }
    }


    private ProcessBuilder setup(java.lang.String[] arguments,java.lang.String[] inputFileNames,byte[][] inputFiles) throws IOException
    {
        String[] copyargs = new String[1];
        if (arguments != null) {
            copyargs = new String[arguments.length + 1];
            System.arraycopy(arguments, 0, copyargs, 1, arguments.length);
        }
        copyargs[0] = EXECUTABLE_PATH;
        
        ProcessBuilder pb = new ProcessBuilder(copyargs);
        java.io.File workingDir = createWorkingDirectory();
        pb.directory(workingDir);
        
        decodeInputFiles(workingDir, inputFileNames, inputFiles);
        
        return pb;
    }


    private Process monitor(Process process, File storageDir)
    {
        java.io.InputStream is;
        java.io.InputStream ein;
        
        synchronized(process) {
            is = process.getInputStream();
            ein = process.getErrorStream();
        }
        java.io.OutputStream fos = null;
        java.io.OutputStream eout = null;
        
        try {
            fos = new java.io.FileOutputStream(new java.io.File(storageDir, STDOUT_FILENAME));
            eout = new java.io.FileOutputStream(new java.io.File(storageDir, STDERR_FILENAME));
        } catch (java.io.FileNotFoundException e) {
            e.printStackTrace();
            return null;
        }
        
        int numBytes = 0, numRead = 0;
        final byte[] buf = new byte[BUFFER_READER_SIZE];
        
        while (numRead >= 0) {
            try {
                numBytes = is.available();
                if (numBytes > buf.length) {
                    numBytes = buf.length;
                }
                if (numBytes == 0) {
                    numBytes = 1;
                }
                numRead = is.read(buf, 0, numBytes);
                if (numRead == -1) {
                    break;
                }
                fos.write(buf, 0, numRead);
                numBytes = ein.available();
                if (numBytes > buf.length) {
                    numBytes = buf.length;
                }
                numRead = ein.read(buf, 0, numBytes);
                if (numRead == -1) {
                    break;
                }
                eout.write(buf, 0, numRead);
            } catch (java.io.IOException e) {
                e.printStackTrace();
                return null;
            }
        
            try {
                Thread.sleep(100);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
        
        try {
            is.close();
            fos.close();
            ein.close();
            eout.close();
        } catch (java.io.IOException e) {
            e.printStackTrace();
        }
        
        return process;
    }
    private String GRAMContact = null;
    private String factoryType = null;
    private String proxyPath = null;
    private Authorization authorization = HostAuthorization.getInstance();
    private Integer xmlSecurity = Constants.ENCRYPTION;
    private Date serviceDuration = null;
    private Date serviceTermination = null;
    private int timeout = GramJob.DEFAULT_TIMEOUT;
    private boolean limitedDelegation = true;
    private boolean delegationEnabled = true;
    private boolean batch = false;
    private GramJob job = null;
    private boolean jobCompleted = false;
    /*
     * Method called when notifications arrive 
     * Update Resource properties to reflect updates 
     * Or when finished we can pull the output back to this machine
     * 
     */
    
    public void stateChanged(GramJob job) {
        StateEnumeration jobState = job.getState();
        boolean holding = job.isHolding();
        logger.debug("========== State Notification ==========");
        printJobState(jobState, holding);
        logger.debug("========================================");
    
        synchronized (this) {
            if ( jobState.equals(StateEnumeration.Done)|| jobState.equals(StateEnumeration.Failed)) {
                logger.debug("Exit Code: " + Integer.toString(job.getExitCode()));
                this.jobCompleted = true;
            }
    
            notifyAll();
        }
    }
    
    private void printJobState(StateEnumeration jobState, boolean holding) {
        String holdString = "";
        if (holding) holdString = "HOLD ";
        logger.debug("Job State: " + holdString + jobState.getValue());
    }
    private EndpointReferenceType getFactoryEPR (String contact, String factoryType) throws Exception {
        URL factoryUrl = ManagedJobFactoryClientHelper.getServiceURL(contact).getURL();
        logger.debug("Factory Url: " + factoryUrl);
    
        return ManagedJobFactoryClientHelper.getFactoryEndpoint(factoryUrl, factoryType);
    }
    /*
     * Do we allow invoker to choose scheduler type
     * 
     */
    private org.globus.exec.generated.JobDescriptionType createJobDescription(String executable, String []args) {
        logger.debug("Creating job for application " + executable);
        org.globus.exec.generated.JobDescriptionType jobDescription = new org.globus.exec.generated.JobDescriptionType();
        jobDescription.setExecutable(executable);
        jobDescription.setArgument(args);
    
    return jobDescription;
    }
    private void processJob(GramJob job, EndpointReferenceType factoryEndpoint, boolean batch) throws
         Exception {
    
        final ExtendedGSSManager manager;
        final String handle;
        final GSSCredential proxy;
    
        logger.debug("Loading Proxy");
        // TODO - delegation
        // we can basically copy the delegation client side code from GRAMJob.java, we may need to implement 
        // a couple of service methods to return delegation points etc, the following proxy stuff can go when 
        // delegation is implemented
        if (proxyPath != null) {
            try {
                manager = (ExtendedGSSManager) ExtendedGSSManager.getInstance();
                handle = "X509_USER_PROXY=" + proxyPath.toString();
                proxy = manager.createCredential(handle.getBytes(),
                    ExtendedGSSCredential.IMPEXP_MECH_SPECIFIC,
                    GSSCredential.DEFAULT_LIFETIME, null,
                    GSSCredential.INITIATE_AND_ACCEPT);
    
                job.setCredentials(proxy);
                System.out.println("User proxy: "  + "X509_USER_PROXY=" + proxyPath.toString());
            } catch (Exception e) {
                logger.error("error obtaining user proxy: " + e.getMessage());
                // don't exit, but resume using default proxy instead
            }
        }
    
        // Generate a Job ID
        logger.debug("Generating ID:");
        UUIDGen uuidgen 	= UUIDGenFactory.getUUIDGen();
        String submissionID = "uuid:" + uuidgen.nextUUID();
        logger.debug("Submission ID: " + submissionID);
    
        if (!batch) {
            logger.debug("Not in batch mode adding listener");
            job.addListener(this);
        }
    
        boolean submitted = false;
    
        while (!submitted) {
            try {
                job.submit(factoryEndpoint, batch, this.limitedDelegation,	submissionID);
                submitted = true;
            } catch (Exception e) {
                logger.debug("Exception while submitting the job request: " + e);
                throw new IOException("Job request error: " + e);
            }
        }
    
        if (batch) {
            logger.debug("CREATED MANAGED JOB SERVICE WITH HANDLE:");
            logger.debug(job.getHandle());
        }
    }
    public void startGramJob(JobDescriptionType jobDescription) throws Exception {
        EndpointReferenceType factoryEndpoint = getFactoryEPR(GRAMContact,factoryType);
        logger.debug("Submitting job");
    
        if (jobDescription != null){
            try {
                logger.debug("Job Submitted: " + jobDescription);
                job = new GramJob(jobDescription);
            } catch (Exception e) {
                throw new IOException("Cant create job from description " + e);
            }
        }
    
        logger.debug("Job:" + job.toString());
    
        job.setTimeOut(timeout);
        job.setAuthorization(authorization);
        job.setMessageProtectionType(xmlSecurity);
        job.setDelegationEnabled(this.delegationEnabled);
        job.setDuration(serviceDuration);
        job.setTerminationTime(serviceTermination);
    
        this.processJob(job, factoryEndpoint, batch);
    }
    /*
     * Method used for testing 
     * Will timeout and refreshStatus - when called gramJob will call the state changed method to 
     * simulate a notification event
     * When we do recieve proper notifications there will probably be an error - we will need to patch gramjob - Martin can explain
     */
    private synchronized void waitForJobCompletion(long maxWaitPerStateNotificationMillis) throws Exception {
    
        long durationToWait = maxWaitPerStateNotificationMillis;
        long startTime;
        StateEnumeration oldState = job.getState();
        // prints one more state initially (Unsubmitted)
        // but cost extra remote call for sure. Null test below instead
    
        while (!this.jobCompleted) {
            startTime = System.currentTimeMillis(); // (re)set start time
            try {
                wait(durationToWait); // wait for a state change notif
            } catch (InterruptedException ie) {
                String errorMessage = "interrupted thread waiting for job to finish";
                logger.error(errorMessage); // no exiting...
            }
    
            // Determine what stopped the wait():
            // A) New job state change notification (good!)
            // wont happen here with testing machine
    
            StateEnumeration currentState = job.getState();
            if (currentState != null && !currentState.equals(oldState)) {
                oldState = currentState; // wait for next state notif
                durationToWait = maxWaitPerStateNotificationMillis; // reset
            } else {
                long now = System.currentTimeMillis();
                long durationWaited = now - startTime;
                // B) Timeout when waiting for a notification (bad)
                // this is what will happen if you cant recieve notifications
                // note - if the state has changed then we wont enter backoff
                if (durationWaited >= durationToWait) {
                    job.refreshStatus();
                    // binary exponential backoff
                    durationToWait = 2 * durationToWait;
                    // C) Some other reasonv
                } else {
                    // wait but only for remainder of timeout duration
                    durationToWait = durationToWait - durationWaited;
                }
            }
        } 
    }

}

